/*
 * upd
 *
 * (C) 1989 Saeko Hirabauashi & Kouichi Hirabayashi
 *
 * Absolutely no warranty. Use this software with your own risk.
 *
 * Permission to use, copy, modify and distribute this software for any
 * purpose and without fee is hereby granted, provided that the above
 * copyright and disclaimer notice.
 */


#include <stdio.h>
#include <sys/types.h>
#include <signal.h>
#include "upd.h"

extern char **FS, **JFS, **OFS, **FILENAME, **JFILENAME;
extern char record[2][RECSIZ];
extern keyfld[2];
extern FILE *infile[2];
extern char cmptyp;
int mflg;		/* 1;N matching */

NODE *parse();
CELL *execute();
FILE *efopen(), *fopen();
char *strsave();

int xargc;
char **xargv;
char *srcprg;
FILE *pfp;
char *cmd;

main(argc, argv) char **argv;
{
  char c, *s, *strpbrk(), *strchr();
  void onint();

  signal(SIGINT, onint);
  signal(SIGFPE, onint);
  cmd = argv[0];
  keyfld[0] = keyfld[1] = 1;
  init();
  while (--argc > 0 && (*++argv)[0] == '-')
	for (s = argv[0]+1; *s; s++)
		if (strcmp(argv[0], "-") == 0)
			break;
		else
		switch (*s) {
		case 'F':
			++s;
			if (strcmp("t", s) == 0)
				*FS = *JFS = "\t";
			else
				*FS = *JFS = s;
			break;
		case 'f':
			if (*(s+1))
				s++;
			else {
				argc--; s = *++argv;
			}
			pfp = efopen(s, "r");
			s += strlen(s) - 1;
			break;
		case 'm':
			mflg++;
			break;
		default:
			if ('0' <= *s && *s <= '9') {
				sscanf(s, "%d%*c%d%c", &keyfld[0], &keyfld[1], &cmptyp);
				s += strlen(s) - 1;
			}
			else
				Usage();
		}

  xargc = argc; xargv = argv;
  if (pfp == NULL && xargc > 0) {
	srcprg = *xargv++; xargc--;
  }

  while (xargc > 0 && strchr(*xargv, '=') != NULL) {
	setvar(*xargv++);
	xargc--;
  }

  initarg(cmd, xargc, xargv);
  if (xargc == 0 || 2 < xargc)
	Usage();
  else {
	infile[0] = efopen(xargv[0], "r"); *FILENAME = xargv[0];
  }
  if (xargc == 2) {
	infile[1] = efopen(xargv[1], "r"); *JFILENAME = xargv[1];
  }
  else {
	infile[1] = stdin; *JFILENAME = "-";
  }
  parse();
  closeall();
  exit(0);
}

Usage()
{
  fprintf(stderr,
	"Usage: upd [-<compare_method>] [-f source | 'cmds'] [master [journal]]\n");
  fprintf(stderr,
	"  compare_method: <master_keypos>.<journal_keypos>[n]\n");
  exit(1);
}

FILE *
efopen(file, mode) char *file, *mode;
{
  FILE *fp, *fopen();

  if ((fp = fopen(file, mode)) == NULL)
	error("cannot open %s", file);
  return fp;
}

error(s, t) char *s, *t;
{
  extern double *NR;

  fprintf(stderr, "upd: ");
  fprintf(stderr, s, t);
  fprintf(stderr, "\n");
  fprintf(stderr, "record number %g\n", *NR);
  exit(1);
}

void
onint(i)
{
  closeall();
  exit(i);
}
